package Analytics;

use strict;
use warnings;

use LWP::UserAgent;
use HTTP::Request::Common;

use XML::Simple;

use Data::Dumper;

sub new {
    my ($class) = @_;
    $class = ref ($class) ? ref ($class) : $class;
    
    my $self = {};
    bless $self, $class;
    my $ua = LWP::UserAgent->new;
	$ua->agent ("Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
	$ua->cookie_jar ({});
	
	$self->{ua} = $ua;
    $self;
}

sub is_logged_in {
    return 1;
}

sub getSiteProfiles {
    my $self = shift;
    my ($account) = @_;
    
    my $ua = $self->{ua};
    
    my $url = 'https://www.google.com/analytics/home/admin?scid=' . $account;
    
    my $res = $ua->get ($url);
    my $body = $res->content;
    
    my %profiles;
    if ($body =~ /name=\"profile_list\"(.*?)<\/select>/ms) {
        my $select = $1;
        while ($select =~ m{<option.*?value="(.*?)".*?>(.*?)</option>}gmis) {
            my ($id, $name) = ($1, $2);
            next if (!$id);
            $profiles{$id} = $name;
        }
    }

    return \%profiles;
}

sub getAccounts {
    my $self = shift;
    
    my $ua = $self->{ua};
    my $url = "https://www.google.com/analytics/home/";
    
    my $res = $ua->get ($url);
    my $body = $res->content;
    
    my %accounts;
    if ($body =~ /name=\"account_list\"(.*?)<\/select>/ms) {
        my $select = $1;
        while ($select =~ m{<option.*?value="(\d+)".*?>(.*?)</option>}mgis) {
            my ($id, $name) = ($1, $2);
            next if (!$id);
            $accounts{$id} = $name;
        }
    }

    return \%accounts;
}

sub getReport {
    my $self = shift;
    
    my ($profile, $start, $stop, $type) = @_;
    
    my $url = "https://www.google.com/analytics/reporting/export?fmt=1&id=$profile&pdr=$start-$stop&cmp=average&rpt=$type";
    
    my $ua = $self->{ua};
    
    my $res = $ua->get ($url);
    
    my $body = $res->content;
    my $xml_ref = XMLin ($body);
	return $xml_ref;
}


sub login {
    my $self = shift;
    my ($user, $pass) = @_;
    my $loginForm = "https://www.google.com/accounts/ServiceLoginBox?service=analytics&nui=1&hl=en-US&continue=http://www.google.com/analytics/home/%3Fet%3Dreset%26hl%3Den-US";
	
	my $ua = $self->{ua};
	my $req = HTTP::Request->new (GET => $loginForm);
	my $res = $ua->request ($req);
	
    die "Request failed" if (!$res->is_success);
    
    $res = $ua->request (POST "https://www.google.com/accounts/ServiceLoginBoxAuth", [
        continue    => "http://www.google.com/analytics/home/?et=reset&amp;hl=en-US",
        service     => "analytics",
        nui         => 1,
        hl          => 'en-US',
        Email       => $user,
        Passwd      => $pass,
    ]);
    
    # Grab the continue link from the response html
    
    my $str = $res->content;
    if ($str =~ /<a target=.* href=\"(.*?)\"/) {
        my $next = $1;
        
        $res = $ua->get ($next);
    }
    else {
        print "didn't find a link\n";
    }
    
}

1;